# NGSpy 6.2 file created by SEQUOIA Cell Designer V21.2 (Build 2021/03/22) on Monday, 26 April, 2021
import time
from ngsolve import *
from netgen.csg import *

p1 = Plane (Pnt(0,0,-0), Vec(0,0,-1) )
p2 = Plane (Pnt(0,0,1.0), Vec( 0,0,1) )
p3 = Plane (Pnt(0,-1.25,0), Vec(0,-1,0) )
p4 = Plane (Pnt(0, 0.75, 0), Vec(0, 1,0) )
p5 = Plane (Pnt(-1.3, 0, 0), Vec(-1, 0, 0) )
p6 = Plane (Pnt(1.2, 0, 0), Vec(1, 0, 0) )
  
planes = p1 * p2 * p3 * p4 * p5 * p6

p_M1_0_1 = OrthoBrick( Pnt(-0.5,-0.71,0.05), Pnt(-0.45,-0.66,0.1) )
p_M1_0_2 = OrthoBrick( Pnt(-0.36,0.23,0.05), Pnt(-0.32,0.35,0.1) )

geo = CSGeometry()
geo.Add(planes - p_M1_0_1 - p_M1_0_2)
regp_M1_0_1  = planes * p_M1_0_1.mat("elec1").maxh(0.1)
geo.Add(regp_M1_0_1 , bcmod=[(regp_M1_0_1,'1')])
regp_M1_0_2  = planes * p_M1_0_2.mat("elec2").maxh(0.1)
geo.Add(regp_M1_0_2 , bcmod=[(regp_M1_0_2,'2')])

# list of dirichlet bc values: 1,2,3,4,5,6,7,8,9,10,11,# 1 p_M1_0_1
# 2 p_M1_0_2
# 3 p_M1_0_3
# 4 p_M1_0_4
# 5 p_M1_0_5
# 6 p_M1_0_6
# 7 p_M1_0_7
# 8 p_M1_0_8
# 9 p_M1_0_9
# 10 p_M1_0_10
# 11 p_M1_0_11
geo.PeriodicSurfaces(p3,p4)
geo.PeriodicSurfaces(p5,p6)

from ngsolve import *
mesh = Mesh(geo.GenerateMesh())
t0 = time.perf_counter()
print(mesh.GetBoundaries())
print(mesh.GetMaterials())
mesh.ngmesh.Save("mesh_py.vol.gz")
